<template>
<st-content heading="Detalle Facultad">
  <st-back-btn/>
  <st-register 
    :key="'st-register-' + componentKey"
    :data="fields"
    v-model="dialog"
    @refresh="refresh"
  />


  <v-row class="my-4">
  <v-col md="12">
  <div class="content-body">
    <div class="table-heading">
      <st-subtitle text="Datos generales"/>
      <st-edit-btn @click="open"/>
    </div>
    <v-row>
      <v-col md="6" v-for="(field,index) in fields" :key="index">
        <v-row align="center" no-gutters>
          <v-col md="4"><v-label>{{ field.label }}</v-label></v-col>
          <v-col md="8"><v-label>{{ field.value }}</v-label></v-col>
        </v-row>
      </v-col>
    </v-row>
  </div>
  </v-col>
  </v-row>

  <st-register-program
    :key="'st-register-program-' + componentKey2"
    v-model="dialog2"
    @refresh="refresh2"
  />

  <v-row class="my-4">
  <v-col md="12">
  <div class="content-body">
    <div class="table-heading">
      <st-search
          text="Buscar por nombre o código"
          @enter="buscar($event)"
        />
        <st-primary-btn
          nombre="Registrar Programa"
          @click="open2"
        />
    </div>
    <st-data-table
        :dataInfo = "{ headers,items,key }"
        :dataPath = "path"
        :loading = "loading"
        :search = search2
    />
    
  </div>
  </v-col>
  </v-row>

</st-content>
</template>

<script>
import Register from '@/components/admin/RegisterFaculty'
import DataTable from '@/components/DataTable'
import Search from '@/components/Search'
import RegisterProgram from '@/components/admin/RegisterProgram'

export default {
  data () {
    return {
      componentKey: 0,
      componentKey2: 0,
      key: null,
      loading: false,
      dialog: false,
      dialog2: false,
      items:[],
      search2: '',
      fields:{
        codigo: { label:'Código', value: '...Cargando' },
        nombre: { label:'Nombre', value: '...Cargando' },
        coordinador: { label:'Coordinador', value: '...Cargando' , id:''},
      },
      headers: [
      {
        text: 'Código',
        align: 'start',
        value: 'codigo',
      },
      {
        text: 'Nombre',
        value: 'nombre',
      },
      {
        text:'Coordinador',
        value:'coordinador.nombres',
      }
      ],
      path:{
        url: '/admin/programas/',
        id: 'idUnidad',
      },
    }
  },
  mounted(){
    this.getInfo()
    this.search('')
  },
  components:{
    'st-register': Register,
    'st-search': Search,
    'st-data-table': DataTable,
    'st-register-program': RegisterProgram,
  },
  methods: {
    open(){
      this.dialog = true
      this.componentKey += 1; //forceRerender
    },
    open2(){
      this.dialog2 = true
      this.componentKey2 += 1
    },
    refresh(value){
      this.dialog = false
      this.getInfo()
    },
    refresh2(value){
      this.dialog2 = false
      this.search()
    },

    async getInfo(){
      try{
        let {data:{data:{unidad}}} = await this.$api.getUnitsByUnitId(this.$route.params.id)
        let fields = this.fields
        fields.codigo.value = unidad.codigo
        fields.nombre.value =  unidad.nombre
        fields.coordinador.value =  unidad.coordinador.nombres
        fields.coordinador.id =  unidad.coordinador.idCoordinador
      } catch (e) {
        this.$store.commit('setError', e)
      }
    },
    async search(value = ''){
      this.loading = true
      try{
        let { data: { data } } = await this.$api.getUnitsByUnitId(this.$route.params.id)
        if (data.programas === null){
          this.items=[]
        }else{
          this.items = data.programas
        }
      }
      catch(e){
        this.$store.commit('setError', e)
      }
      this.loading = false

    },
  buscar(value){
      this.loading = true
      this.search2 = value
      this.loading = false

    }
  }
}
</script>

<style scoped lang="scss">
</style>
